# Generated from permalinkable-1.0.1.gem by gem2rpm -*- rpm-spec -*-
%global gem_name permalinkable

Name: rubygem-%{gem_name}
Version: 1.0.1
Release: 1%{?dist}
Summary: Generate permalink attributes on ActiveRecord FPE'ed from database ids
License: MIT
URL: http://rubygems.org/gems/permalinkable
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
BuildRequires: ruby(release)
BuildRequires: rubygems-devel
BuildRequires: ruby
# BuildRequires: rubygem(sqlite3) >= 1.3
# BuildRequires: rubygem(sqlite3) < 2
# BuildRequires: rubygem(rspec) >= 3.0
# BuildRequires: rubygem(rspec) < 4
BuildArch: noarch

%description
This is a gem originated from another gem called permalink.
Since I often want a permalink that provides no way to tell the database ids,
I came up with the idea about encrypting the id and prepending it to the
permalink.
For more information about FPE(Format Preserving Encryption), please consult
the wikipedia.
The encryption method of current release is simply RC4-40 with a configurable
key.
Note, RC4-40 is not a strong encryption algorithm at all, and you shouldn't
rely on it to delivery sensitive
information. Also, to prevent inconsistance of encryption, and
duplication(although the chance is very low)
you should keep your key as a secret and never change it.
The original implementation of generating permalink involves a infite loop to
check uniqueness in database.
It's slow, inefficient and most importantly, it still can't prevent race
condition. And since we are using
a FPE algorithm on the database id, which is garanteed to be unique from
database, we don't need to put ourselves
in that inefficient loop.
Finally, what's the purpose of this gem?
It's only a gem that helps hiding your database ids.


%package doc
Summary: Documentation for %{name}
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version}

%build
# Create the gem as gem install only works on a gem file
gem build ../%{gem_name}-%{version}.gemspec

# %%gem_install compiles any C extensions and installs the gem into ./%%gem_dir
# by default, so that we can move it into the buildroot in %%install
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/



%check
pushd .%{gem_instdir}
# rspec spec
popd

%files
%dir %{gem_instdir}
%{gem_instdir}/.DS_Store
%exclude %{gem_instdir}/.gitignore
%exclude %{gem_instdir}/.rvmrc
%exclude %{gem_instdir}/.travis.yml
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%exclude %{gem_instdir}/.rspec
%{gem_instdir}/Gemfile
%{gem_instdir}/Gemfile.lock
%doc %{gem_instdir}/README.md
%{gem_instdir}/permalink.gemspec
%{gem_instdir}/spec

%changelog
* Tue Apr 19 2022 mockbuilder - 1.0.1-1
- Initial package
